#ifndef _JZ_PIC32MX_PORT_H_
#define _JZ_PIC32MX_PORT_H_
#include <stdint.h>


#if defined(_USE_SFRS_BASE_ADDR)
  extern const void * _sfrs_base_addr_1;
  #define _port_base_addr        (_sfrs_base_addr_1 + 0x6000)
#else
  #define _port_base_addr	((const void *)0xBF886000)
#endif

#if defined(__32MX1XX__) || defined(__32MX2XX__)

  #define _PORT_ADDR(x)	(_port_base_addr + (x)*0x100)

  /* x=0:PORTA , x=1:PORTB , x=2:PORTC */
  #define ANSEL(x)           (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x00))
  #define ANSEL_CLR(x)       (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x04))
  #define ANSEL_SET(x)       (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x08))
  #define ANSEL_INV(x)       (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x0C))

  #define TRIS(x)            (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x10))
  #define TRIS_CLR(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x14))
  #define TRIS_SET(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x18))
  #define TRIS_INV(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x1C))

  #define PORT(x)            (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x20))
  #define PORT_CLR(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x24))
  #define PORT_SET(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x28))
  #define PORT_INV(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x2C))

  #define LAT(x)             (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x30))
  #define LAT_CLR(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x34))
  #define LAT_SET(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x38))
  #define LAT_INV(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x3C))

  #define ODC(x)             (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x40))
  #define ODC_CLR(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x44))
  #define ODC_SET(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x48))
  #define ODC_INV(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x4C))

  #define CNPU(x)            (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x50))
  #define CNPU_CLR(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x54))
  #define CNPU_SET(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x58))
  #define CNPU_INV(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x5C))

  #define CNPD(x)            (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x60))
  #define CNPD_CLR(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x64))
  #define CNPD_SET(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x68))
  #define CNPD_INV(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x6C))

  #define CNCON(x)           (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x70))
  #define CNCON_CLR(x)       (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x74))
  #define CNCON_SET(x)       (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x78))
  #define CNCON_INV(x)       (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x7C))

  #define CNEN(x)            (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x80))
  #define CNEN_CLR(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x84))
  #define CNEN_SET(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x88))
  #define CNEN_INV(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x8C))

  #define CNSTAT(x)          (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x90))
  #define CNSTAT_CLR(x)      (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x94))
  #define CNSTAT_SET(x)      (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x98))
  #define CNSTAT_INV(x)      (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x9C))

    #define CNCONx_SIDL     0x0D
    #define CNCONx_ON       0x0F

#elif defined(__32MX3XX__) || defined(__32MX4XX__)

  #define _PORT_ADDR(x)	(_port_base_addr + (x)*0x40)

  #define TRIS(x)            (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x00))
  #define TRIS_CLR(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x04))
  #define TRIS_SET(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x08))
  #define TRIS_INV(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x0C))

  #define PORT(x)            (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x10))
  #define PORT_CLR(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x14))
  #define PORT_SET(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x18))
  #define PORT_INV(x)        (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x1C))

  #define LAT(x)             (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x20))
  #define LAT_CLR(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x24))
  #define LAT_SET(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x28))
  #define LAT_INV(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x2C))

  #define ODC(x)             (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x30))
  #define ODC_CLR(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x34))
  #define ODC_SET(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x38))
  #define ODC_INV(x)         (*(volatile uint16_t *)(_PORT_ADDR(x) + 0x3C))
#endif

#endif /* _JZ_PIC32MX_PORT_H_ */
