#ifndef _JZ_P32MX_SYS_H_
#define _JZ_P32MX_SYS_H_
#include <stdint.h>
  /* Peripheral Port Control */
  #define PMCON            (*(volatile unsigned *)0xBF807000)
  #define PMCON_CLR        (*(volatile unsigned *)0xBF807004)
  #define PMCON_SET        (*(volatile unsigned *)0xBF807008)
  #define PMCON_INV        (*(volatile unsigned *)0xBF80700C)
  #define PMMODE           (*(volatile unsigned *)0xBF807010)
  #define PMMODE_CLR       (*(volatile unsigned *)0xBF807014)
  #define PMMODE_SET       (*(volatile unsigned *)0xBF807018)
  #define PMMODE_INV       (*(volatile unsigned *)0xBF80701C)
  #define PMADDR           (*(volatile unsigned *)0xBF807020)
  #define PMADDR_CLR       (*(volatile unsigned *)0xBF807024)
  #define PMADDR_SET       (*(volatile unsigned *)0xBF807028)
  #define PMADDR_INV       (*(volatile unsigned *)0xBF80702C)
  #define PMDOUT           (*(volatile unsigned *)0xBF807030)
  #define PMDOUT_CLR       (*(volatile unsigned *)0xBF807034)
  #define PMDOUT_SET       (*(volatile unsigned *)0xBF807038)
  #define PMDOUT_INV       (*(volatile unsigned *)0xBF80703C)
  #define PMDIN            (*(volatile unsigned *)0xBF807040)
  #define PMDIN_CLR        (*(volatile unsigned *)0xBF807044)
  #define PMDIN_SET        (*(volatile unsigned *)0xBF807048)
  #define PMDIN_INV        (*(volatile unsigned *)0xBF80704C)
  #define PMAEN            (*(volatile unsigned *)0xBF807050)
  #define PMAEN_CLR        (*(volatile unsigned *)0xBF807054)
  #define PMAEN_SET        (*(volatile unsigned *)0xBF807058)
  #define PMAEN_INV        (*(volatile unsigned *)0xBF80705C)
  #define PMSTAT           (*(volatile unsigned *)0xBF807060)
  #define PMSTAT_CLR       (*(volatile unsigned *)0xBF807064)
  #define PMSTAT_SET       (*(volatile unsigned *)0xBF807068)
  #define PMSTAT_INV       (*(volatile unsigned *)0xBF80706C)

    #define PMCON_RDSP                     0x00
    #define PMCON_WRSP                     0x01
    #define PMCON_CS1P                     0x03
    #define PMCON_ALP                      0x05
    #define PMCON_CSF                      0x06
    #define PMCON_PTRDEN                   0x08
    #define PMCON_PTWREN                   0x09
    #define PMCON_PMPTTL                   0x0A
    #define PMCON_ADRMUX                   0x0B
    #define PMCON_SIDL                     0x0D
    #define PMCON_ON                       0x0F
    #define PMCON_CSF0                     0x06
    #define PMCON_CSF1                     0x07
    #define PMCON_ADRMUX0                  0x0B
    #define PMCON_ADRMUX1                  0x0C
    #define PMCON_PSIDL                    0x0D
    #define PMCON_PMPEN                    0x0F
    #define PMMODE_WAITE                   0x00
    #define PMMODE_WAITM                   0x02
    #define PMMODE_WAITB                   0x06
    #define PMMODE_MODE                    0x08
    #define PMMODE_INCM                    0x0B
    #define PMMODE_IRQM                    0x0D
    #define PMMODE_BUSY                    0x0F
    #define PMMODE_WAITE0                  0x00
    #define PMMODE_WAITE1                  0x01
    #define PMMODE_WAITM0                  0x02
    #define PMMODE_WAITM1                  0x03
    #define PMMODE_WAITM2                  0x04
    #define PMMODE_WAITM3                  0x05
    #define PMMODE_WAITB0                  0x06
    #define PMMODE_WAITB1                  0x07
    #define PMMODE_MODE0                   0x08
    #define PMMODE_MODE1                   0x09
    #define PMMODE_INCM0                   0x0B
    #define PMMODE_INCM1                   0x0C
    #define PMMODE_IRQM0                   0x0D
    #define PMMODE_IRQM1                   0x0E
    #define PMADDR_ADDR                    0x00
    #define PMADDR_CS1                     0x0E
    #define PMADDR_PADDR                   0x00
    #define PMADDR_CS                      0x0E

    #define PMSTAT_OB0E                    0x00
    #define PMSTAT_OB1E                    0x01
    #define PMSTAT_OB2E                    0x02
    #define PMSTAT_OB3E                    0x03
    #define PMSTAT_OBUF                    0x06
    #define PMSTAT_OBE                     0x07
    #define PMSTAT_IB0F                    0x08
    #define PMSTAT_IB1F                    0x09
    #define PMSTAT_IB2F                    0x0A
    #define PMSTAT_IB3F                    0x0B
    #define PMSTAT_IBOV                    0x0E
    #define PMSTAT_IBF                     0x0F

  /* PMD -- Peripheral Module Disable */
  /* x=0: PMD0 .. x=6:PMD6 */
  #define PMD(x)             (*(volatile unsigned *)(0xBF80F240 + (x)*0x10))
  #define PMD_CLR(x)         (*(volatile unsigned *)(0xBF80F244 + (x)*0x10))
  #define PMD_SET(x)         (*(volatile unsigned *)(0xBF80F248 + (x)*0x10))
  #define PMD_INV(x)         (*(volatile unsigned *)(0xBF80F24C + (x)*0x10))

  #if defined(__32MX1XX__) || defined(__32MX2XX__)
    #define PMD1_AD1MD                     0x00
    #define PMD1_CTMUMD                    0x08
    #define PMD1_CVRMD                     0x0C

    #define PMD2_CMP1MD                    0x00
    #define PMD2_CMP2MD                    0x01
    #define PMD2_CMP3MD                    0x02

    #define PMD3_IC1MD                     0x00
    #define PMD3_IC2MD                     0x01
    #define PMD3_IC3MD                     0x02
    #define PMD3_IC4MD                     0x03
    #define PMD3_IC5MD                     0x04
    #define PMD3_OC1MD                     0x10
    #define PMD3_OC2MD                     0x11
    #define PMD3_OC3MD                     0x12
    #define PMD3_OC4MD                     0x13
    #define PMD3_OC5MD                     0x14

    #define PMD4_T1MD                      0x00
    #define PMD4_T2MD                      0x01
    #define PMD4_T3MD                      0x02
    #define PMD4_T4MD                      0x03
    #define PMD4_T5MD                      0x04

    #define PMD5_U1MD                      0x00
    #define PMD5_U2MD                      0x01
    #define PMD5_SPI1MD                    0x08
    #define PMD5_SPI2MD                    0x09
    #define PMD5_I2C1MD                    0x10
    #define PMD5_I2C2MD                    0x11
    #define PMD5_USB1MD                    0x18

    #define PMD6_RTCCMD                    0x00
    #define PMD6_REFOMD                    0x01
    #define PMD6_PMPMD                     0x10
  #endif

  /* Peripheral Pin Select (PPS) */
#if defined(_USE_SFRS_BASE_ADDR)
  extern const void * _sfrs_base_addr_0;
  #define _pps_base_addr        (_sfrs_base_addr_0 + 0xFA00)
#else
  #define _pps_base_addr	((const void *)0xBF80FA00)
#endif

#define _PPS_ADDR	 (_pps_base_addr)

  /* Group 1 */
  #define INT4R            (*(volatile uint8_t *)(_PPS_ADDR + 0x10)
  #define T2CKR            (*(volatile uint8_t *)(_PPS_ADDR + 0x18)
  #define IC4R             (*(volatile uint8_t *)(_PPS_ADDR + 0x34)
  #define SS1R             (*(volatile uint8_t *)(_PPS_ADDR + 0x88)
  #define REFCLKIR         (*(volatile uint8_t *)(_PPS_ADDR + 0xB8)

    #define PPS1_IN_RPA0	0
    #define PPS1_IN_RPB3	1
    #define PPS1_IN_RPB4	2
    #define PPS1_IN_RPB15	3
    #define PPS1_IN_RPB7	4
    #define PPS1_IN_RPC7	5
    #define PPS1_IN_RPC0	6
    #define PPS1_IN_RPC5	7

  #define RPA0R            (*(volatile uint8_t *)(_PPS_ADDR + 0x100)
  #define RPB3R            (*(volatile uint8_t *)(_PPS_ADDR + 0x138)
  #define RPB4R            (*(volatile uint8_t *)(_PPS_ADDR + 0x13C)
  #define RPB15R           (*(volatile uint8_t *)(_PPS_ADDR + 0x168)
  #define RPB7R            (*(volatile uint8_t *)(_PPS_ADDR + 0x148)
  #define RPC7R            (*(volatile uint8_t *)(_PPS_ADDR + 0x188)
  #define RPC0R            (*(volatile uint8_t *)(_PPS_ADDR + 0x16C)
  #define RPC5R            (*(volatile uint8_t *)(_PPS_ADDR + 0x180)

    #define PPS1_OUT_NONE	0
    #define PPS1_OUT_U1TX	1
    #define PPS1_OUT_U2RTS	2
    #define PPS1_OUT_SS1	3
    #define PPS1_OUT_OC1	5
    #define PPS1_OUT_C2OUT	7

  /* Group 2 */
  #define INT3R            (*(volatile uint8_t *)(_PPS_ADDR + 0x0C)
  #define T3CKR            (*(volatile uint8_t *)(_PPS_ADDR + 0x1C)
  #define IC3R             (*(volatile uint8_t *)(_PPS_ADDR + 0x30)
  #define U1CTSR           (*(volatile uint8_t *)(_PPS_ADDR + 0x54)
  #define U2RXR            (*(volatile uint8_t *)(_PPS_ADDR + 0x58)
  #define SDI1R            (*(volatile uint8_t *)(_PPS_ADDR + 0x84)

    #define PPS2_IN_RPA1	0
    #define PPS2_IN_RPB5	1
    #define PPS2_IN_RPB1	2
    #define PPS2_IN_RPB11	3
    #define PPS2_IN_RPB8	4
    #define PPS2_IN_RPA8	5
    #define PPS2_IN_RPC8	6
    #define PPS2_IN_RPA9	7

  #define RPA1R            (*(volatile uint8_t *)(_PPS_ADDR + 0x104)
  #define RPB5R            (*(volatile uint8_t *)(_PPS_ADDR + 0x140)
  #define RPB1R            (*(volatile uint8_t *)(_PPS_ADDR + 0x130)
  #define RPB11R           (*(volatile uint8_t *)(_PPS_ADDR + 0x158)
  #define RPB8R            (*(volatile uint8_t *)(_PPS_ADDR + 0x14C)
  #define RPA8R            (*(volatile uint8_t *)(_PPS_ADDR + 0x120)
  #define RPC8R            (*(volatile uint8_t *)(_PPS_ADDR + 0x18C)
  #define RPA9R            (*(volatile uint8_t *)(_PPS_ADDR + 0x124)

    #define PPS2_OUT_NONE	0
    #define PPS2_OUT_SDO1	3
    #define PPS2_OUT_SDO2	4
    #define PPS2_OUT_OC2	5

  /* Group 3 */
  #define INT2R            (*(volatile uint8_t *)(_PPS_ADDR + 0x08)
  #define T4CKR            (*(volatile uint8_t *)(_PPS_ADDR + 0x20)
  #define IC1R             (*(volatile uint8_t *)(_PPS_ADDR + 0x28)
  #define IC5R             (*(volatile uint8_t *)(_PPS_ADDR + 0x38)
  #define U1RXR            (*(volatile uint8_t *)(_PPS_ADDR + 0x50)
  #define U2CTSR           (*(volatile uint8_t *)(_PPS_ADDR + 0x5C)
  #define SDI2R            (*(volatile uint8_t *)(_PPS_ADDR + 0x90)
  #define OCFBR            (*(volatile uint8_t *)(_PPS_ADDR + 0x4C)

    #define PPS3_IN_RPA2	0
    #define PPS3_IN_RPB6	1
    #define PPS3_IN_RPA4	2
    #define PPS3_IN_RPB13	3
    #define PPS3_IN_RPB2	4
    #define PPS3_IN_RPC6	5
    #define PPS3_IN_RPC1	6
    #define PPS3_IN_RPC3	7

  #define RPA2R            (*(volatile uint8_t *)(_PPS_ADDR + 0x108)
  #define RPB6R            (*(volatile uint8_t *)(_PPS_ADDR + 0x144)
  #define RPA4R            (*(volatile uint8_t *)(_PPS_ADDR + 0x110)
  #define RPB13R           (*(volatile uint8_t *)(_PPS_ADDR + 0x160)
  #define RPB2R            (*(volatile uint8_t *)(_PPS_ADDR + 0x134)
  #define RPC6R            (*(volatile uint8_t *)(_PPS_ADDR + 0x184)
  #define RPC1R            (*(volatile uint8_t *)(_PPS_ADDR + 0x170)
  #define RPC3R            (*(volatile uint8_t *)(_PPS_ADDR + 0x178)

    #define PPS3_OUT_NONE	0
    #define PPS3_OUT_SDO1	3
    #define PPS3_OUT_SDO2	4
    #define PPS3_OUT_OC4	5
    #define PPS3_OUT_OC5	6
    #define PPS3_OUT_REFCLKO	7

  /* Group 4 */
  #define INT1R            (*(volatile uint8_t *)(_PPS_ADDR + 0x04)
  #define T5CKR            (*(volatile uint8_t *)(_PPS_ADDR + 0x24)
  #define IC2R             (*(volatile uint8_t *)(_PPS_ADDR + 0x2C)
  #define SS2R             (*(volatile uint8_t *)(_PPS_ADDR + 0x94)
  #define OCFAR            (*(volatile uint8_t *)(_PPS_ADDR + 0x48)

    #define PPS4_IN_RPA3	0
    #define PPS4_IN_RPB14	1
    #define PPS4_IN_RPB0	2
    #define PPS4_IN_RPB10	3
    #define PPS4_IN_RPB9	4
    #define PPS4_IN_RPC9	5
    #define PPS4_IN_RPC2	6
    #define PPS4_IN_RPC4	7

  #define RPA3R            (*(volatile uint8_t *)(_PPS_ADDR + 0x10C)
  #define RPB14R           (*(volatile uint8_t *)(_PPS_ADDR + 0x164)
  #define RPB0R            (*(volatile uint8_t *)(_PPS_ADDR + 0x12C)
  #define RPB10R           (*(volatile uint8_t *)(_PPS_ADDR + 0x154)
  #define RPB9R            (*(volatile uint8_t *)(_PPS_ADDR + 0x150)
  #define RPC9R            (*(volatile uint8_t *)(_PPS_ADDR + 0x190)
  #define RPC2R            (*(volatile uint8_t *)(_PPS_ADDR + 0x174)
  #define RPC4R            (*(volatile uint8_t *)(_PPS_ADDR + 0x17C)

    #define PPS4_OUT_NONE	0
    #define PPS4_OUT_U1RTS	1
    #define PPS4_OUT_U2TX	2
    #define PPS4_OUT_SS2	4
    #define PPS4_OUT_OC3	5
    #define PPS4_OUT_C1OUT	7

  /* Bus Matrix Configuration */
  #define BMXCON           (*(volatile unsigned *)0xBF882000)
  #define BMXCON_CLR       (*(volatile unsigned *)0xBF882004)
  #define BMXCON_SET       (*(volatile unsigned *)0xBF882008)
  #define BMXCON_INV       (*(volatile unsigned *)0xBF88200C)
  #define BMXDKPBA         (*(volatile unsigned *)0xBF882010)
  #define BMXDKPBA_CLR     (*(volatile unsigned *)0xBF882014)
  #define BMXDKPBA_SET     (*(volatile unsigned *)0xBF882018)
  #define BMXDKPBA_INV     (*(volatile unsigned *)0xBF88201C)
  #define BMXDUDBA         (*(volatile unsigned *)0xBF882020)
  #define BMXDUDBA_CLR     (*(volatile unsigned *)0xBF882024)
  #define BMXDUDBA_SET     (*(volatile unsigned *)0xBF882028)
  #define BMXDUDBA_INV     (*(volatile unsigned *)0xBF88202C)
  #define BMXDUPBA         (*(volatile unsigned *)0xBF882030)
  #define BMXDUPBA_CLR     (*(volatile unsigned *)0xBF882034)
  #define BMXDUPBA_SET     (*(volatile unsigned *)0xBF882038)
  #define BMXDUPBA_INV     (*(volatile unsigned *)0xBF88203C)
  #define BMXDRMSZ         (*(volatile unsigned *)0xBF882040)
  #define BMXPUPBA         (*(volatile unsigned *)0xBF882050)
  #define BMXPUPBA_CLR     (*(volatile unsigned *)0xBF882054)
  #define BMXPUPBA_SET     (*(volatile unsigned *)0xBF882058)
  #define BMXPUPBA_INV     (*(volatile unsigned *)0xBF88205C)
  #define BMXPFMSZ         (*(volatile unsigned *)0xBF882060)
  #define BMXBOOTSZ        (*(volatile unsigned *)0xBF882070)

    #define BMXCON_BMXARB                  0x00
    #define BMXCON_BMXWSDRM                0x06
    #define BMXCON_BMXERRIS                0x10
    #define BMXCON_BMXERRDS                0x11
    #define BMXCON_BMXERRDMA               0x12
    #define BMXCON_BMXERRICD               0x13
    #define BMXCON_BMXERRIXI               0x14
    #define BMXCON_BMXCHEDMA               0x1A

#endif /* _JZ_P32MX_SYS_H_ */
