#ifndef _JZ_P32MX_TIMER_H_
#define _JZ_P32MX_TIMER_H_
#include <stdint.h>

#if defined(_USE_SFRS_BASE_ADDR)
  extern const void * _sfrs_base_addr_0;
  #define _timer_base_addr        (_sfrs_base_addr_0 + 0x0600)
#else
  #define _timer_base_addr	0xBF800600
#endif

#define _TIMER_ADDR(x)	(_timer_base_addr + (x)*0x200)

  /* x=0: T1 x=4:T5 */
  #define T_CON(x)           (*(volatile uint16_t *)(_TIMER_ADDR(x) + 0x00))
  #define T_CON_CLR(x)       (*(volatile uint16_t *)(_TIMER_ADDR(x) + 0x04))
  #define T_CON_SET(x)       (*(volatile uint16_t *)(_TIMER_ADDR(x) + 0x08))
  #define T_CON_INV(x)       (*(volatile uint16_t *)(_TIMER_ADDR(x) + 0x0C))
  #define TMR(x)             (*(volatile uint16_t *)(_TIMER_ADDR(x) + 0x10))
  #define TMR_CLR(x)         (*(volatile uint16_t *)(_TIMER_ADDR(x) + 0x14))
  #define TMR_SET(x)         (*(volatile uint16_t *)(_TIMER_ADDR(x) + 0x18))
  #define TMR_INV(x)         (*(volatile uint16_t *)(_TIMER_ADDR(x) + 0x1C))
  #define PR(x)              (*(volatile uint16_t *)(_TIMER_ADDR(x) + 0x20))
  #define PR_CLR(x)          (*(volatile uint16_t *)(_TIMER_ADDR(x) + 0x24))
  #define PR_SET(x)          (*(volatile uint16_t *)(_TIMER_ADDR(x) + 0x28))

    #define T_CON_TCS                     0x01
    #define T_CON_TSYNC                   0x02	// T1 Only
    #define T_CON_T32                     0x03	// T2,T4 Only
    #define T_CON_TCKPS                   0x04
    #define T_CON_TGATE                   0x07
    #define T_CON_TWIP                    0x0B	// T1 Only
    #define T_CON_TWDIS                   0x0C	// T1 Only
    #define T_CON_SIDL                    0x0D
    #define T_CON_ON                      0x0F

#endif /* _JZ_P32MX_TIMER_H_ */
