#ifndef _JZ_TIMER_H_
#define _JZ_TIMER_H_
#include <stdint.h>

extern volatile uint32_t timer_ticks;
extern void (* timer_callback)(void);

#define TIMER_HZ_MIN		   50
#define TIMER_HZ_MAX		 1000
#define TIMER_HZ_DEFAULT	  100

#if defined(__32MX1XX__) || defined(__32MX2XX__)
  #define timer_hz		__2xx_timer_hz
  #define __timer_start		____2xx_timer_start
  #define timer_start		__2xx_timer_start
  #define timer_stop		__2xx_timer_stop
#elif defined(__32MX3XX__) || defined(__32MX4XX__)
  #define timer_hz		__4xx_timer_hz
  #define __timer_start		____4xx_timer_start
  #define timer_start		__4xx_timer_start
  #define timer_stop		__4xx_timer_stop
#endif

int timer_hz();
void __timer_start(int prescale, int interval);
void timer_start(int hz);
void timer_stop();

#endif /* _JZ_TIMER_H_ */
