#define	_CP0_COUNT	$9
#define	_CP0_COMPARE	$11
#define	_CP0_STATUS	$12
#define	_CP0_CAUSE	$13
#define	_CP0_EPC	$14
#define	_CP0_CONFIG	$16
#define	_CP0_INTCTL	$12,1
#define	_CP0_SRSCTL	$12,2
#define	_CP0_EBASE	$15,1

	.set nomips16

	.section .app_reset,"ax",@progbits
	.globl _start
	.ent   _start
	.set noreorder
#	.set noat
_start:
        la      $k0, _start_k0
	j	$k0
	nop
_start_k0:
	mfc0    $t0,_CP0_CONFIG
	ext     $t1,$t0,22,1              # Extract UDI from Config register
	sll     $t1,$t1,17                # Move UDI to Status.CEE location
	mfc0    $t0,_CP0_STATUS
	and     $t0,$t0,0x00180000        # Preserve SR, NMI
	or      $t0,$t1,$t0                # Include Status.CEE (from UDI)
	mtc0    $t0,_CP0_STATUS

	mfc0	$a0, _CP0_SRSCTL
	andi	$v0, $a0, 0xf
	beqz	$v0, 1f
	nop
	ins	$a0, $zero, 8, 4
	mtc0	$a0, _CP0_SRSCTL
1:
        la      $k0, _start_k1
	mtc0	$k0, _CP0_EPC
	nop
	eret

_start_k1:
	la      $sp, __stack
	la      $gp, _gp
	##################################################################
	# Initialize Global Pointer in Shadow Set
	#   The SRSCtl's PSS field must be set to the shadow set in which
	#   to initialize the global pointer.  Since we only have a
	#   single shadow set (besides the normal), we will initialize
	#   SRSCtl<PSS> to SRSCtl<HSS>.  We then write the global pointer
	#   to the previous shadow set to ensure that on interrupt, the
	#   global pointer has been initialized.
	##################################################################
	mfc0    $t1, _CP0_SRSCTL          # Read SRSCtl register
	add     $t3, $t1,$zero              # Save off current SRSCtl
	ext     $t2, $t1,26,4              # to obtain HSS field
	ins     $t1, $t2,6,4               # Put HSS field
	mtc0    $t1, _CP0_SRSCTL          # into SRSCtl<PSS>
	wrpgpr  $gp, $gp                   # Set global pointer in PSS
	mtc0    $t3, _CP0_SRSCTL          # Restore SRSCtl

	mfc0    $t0, _CP0_STATUS
	and     $t0, $t0,0x005A0000        # Preserve SR, NMI (and CEE ?)
	mtc0    $t0, _CP0_STATUS
 
	la      $t0, _bss_begin
	la      $t1, _bss_end
	b       _bss_check
	nop
_bss_init:      
	sw      $zero,0x0($t0)
	sw      $zero,0x4($t0)
	sw      $zero,0x8($t0)
	sw      $zero,0xc($t0)
	addu    $t0,16
_bss_check:
	bltu    $t0,$t1,_bss_init
	nop
	la      $t0,_data_image_begin
	la      $t1,_data_begin
	la      $t2,_data_end
	b       _init_check
	nop
_init_data:     
	lw      $t3,($t0)
	sw      $t3,($t1)
	addu    $t0,4
	addu    $t1,4
_init_check:
	bltu    $t1,$t2,_init_data
	nop
	mtc0    $zero,_CP0_COUNT
	li      $t2,-1
	mtc0    $t2,_CP0_COMPARE
	##################################################################
	# Initialize EBase register
	##################################################################
	la      $t1,_ebase_address
	mtc0    $t1,_CP0_EBASE
	##################################################################
	# Initialize CAUSE registers
	# - Enable counting of Count register <DC = 0>
	# - Use special exception vector <IV = 1>
	# - Clear pending software interrupts <IP1:IP0 = 0>
	##################################################################
	li      $t1,0x00800000
	mtc0    $t1,_CP0_CAUSE


	##################################################################
	# Call main. We do this via a thunk in the text section so that
	# a normal jump and link can be used, enabling the startup code
	# to work properly whether main is written in MIPS16 or MIPS32
	# code. I.e., the linker will correctly adjust the JAL to JALX if
	# necessary
	##################################################################
	and     $a0,$a0,0
	and     $a1,$a1,0
	la      $t0,_main_entry
	jr      $t0
	nop
	.end _start

	##################################################################
	# General Exception Vector Handler
	# Jumps to _general_exception_handler
	##################################################################
	.section .gen_handler0,"ax",@progbits
	.ent _gen_exception
_gen_exception:
	.end _gen_exception

	.section .gen_handler,"ax",@progbits
        la      $k0, _start_k0
        jr      $k0                      # Jump to kseg0
        nop

	.text
	.ent _main_entry
_main_entry:
	jal main
	nop
1:
	b       1b
	nop
	.end _main_entry
 
	.section .reset,"ax",@progbits
        la      $k0, _start_k0
        jr      $k0                      # Jump to kseg0
        nop

