#include <p32mx/p32mx_core.h>
#include <p32mx/p32mx_clkc.h>

unsigned __sysclk;

static void get_sysclk()
{
	__sysclk = __clkc_get_sysclk();
}

void delay_us(unsigned int us)
{
	int loop_us = 0;
	int i;

	if (__sysclk == 0) {
		get_sysclk();
	}
	loop_us = __sysclk / 2000000;
	for (i=0; i<us; i++) {
		__delay_loop_1(loop_us);
	}
}

void delay_ms(unsigned int ms)
{
	int loop_ms = 0;
	int i;

	if (__sysclk == 0) {
		get_sysclk();
	}
	loop_ms = __sysclk / 2000;
	for (i=0; i<ms; i++) {
		__delay_loop_1(loop_ms);
	}
}
